/*************************************************
* Default Engine Header File                     *
* (C) 1999-2004 The Botan Project                *
*************************************************/

#ifndef BOTAN_DEFAULT_ENGINE_H__
#define BOTAN_DEFAULT_ENGINE_H__

#include <botan/engine.h>

namespace Botan {

/*************************************************
* Default Engine                                 *
*************************************************/
class Default_Engine : public Engine
   {
   public:
      IF_Operation* if_op(const BigInt&, const BigInt&, const BigInt&,
                          const BigInt&, const BigInt&, const BigInt&,
                          const BigInt&, const BigInt&) const;

      DSA_Operation* dsa_op(const DL_Group&, const BigInt&,
                            const BigInt&) const;

      NR_Operation* nr_op(const DL_Group&, const BigInt&, const BigInt&) const;

      ELG_Operation* elg_op(const DL_Group&, const BigInt&,
                            const BigInt&) const;

      DH_Operation* dh_op(const DL_Group&, const BigInt&) const;

      ModularReducer* reducer(const BigInt&, bool) const;
   };

}

#endif
